﻿unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, ComCtrls, ExtCtrls,
  UnitData, UnitFunc, UnitZumenTitle, UnitZumenPaper, UnitZumenLayer,
  UnitZumenColor, UnitZumenLtype, UnitZumenWidth, UnitZumenFont,
  UnitDataGraph, UnitGraph ;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Panel2: TPanel;
    Panel3: TPanel;
    PaintBox1: TPaintBox;
    RadioGroup1: TRadioGroup;
    Button8: TButton;
    Label1: TLabel;
    Label2: TLabel;
    TreeView1: TTreeView;
    StatusBar1: TStatusBar;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
  private
    { Private 宣言 }
  public
    { Public 宣言 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// 起動時
procedure TForm1.FormShow(Sender: TObject);
begin
   CData := TDataClass.Create ;
   gp := TGraphClass.Create ;
   // Direct2D時、最初の描画が遅くなるため最初に一度実行しておく
   gp.SetDisplayMode(2);
   gp.G_Start(PaintBox1.Canvas);
   gp.G_End ;
end;

// 終了時
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   gp.Free;
   CData.Free;
end;

// [図面情報｜図面表題欄の設定]
procedure TForm1.Button1Click(Sender: TObject);
begin
   FmZumenTitle.P_CData := CData ;
   FmZumenTitle.ShowModal ;
   if (FmZumenTitle.P_OK) then begin
      // OK
   end;
end;

// [図面構造｜用紙の設定]
procedure TForm1.Button2Click(Sender: TObject);
begin
   FmZumenPaper.P_CData := CData ;
   FmZumenPaper.ShowModal ;
   if (FmZumenPaper.P_OK) then begin
      // OK
   end;
end;

// [図面構造｜レイヤの設定]
procedure TForm1.Button3Click(Sender: TObject);
begin
   FmZumenLayer.P_CData := CData ;
   FmZumenLayer.ShowModal ;
end;

// [図面構造｜色の設定]
procedure TForm1.Button4Click(Sender: TObject);
begin
   FmZumenColor.P_CData := CData ;
   FmZumenColor.ShowModal ;
end;

// [図面構造｜線種の設定]
procedure TForm1.Button5Click(Sender: TObject);
begin
   FmZumenLtype.P_CData := CData ;
   FmZumenLtype.ShowModal ;
end;

// [図面構造｜線幅の設定]
procedure TForm1.Button6Click(Sender: TObject);
begin
   FmZumenWidth.P_CData := CData ;
   FmZumenWidth.ShowModal ;
end;

// [図面構造｜文字フォントの設定]
procedure TForm1.Button7Click(Sender: TObject);
begin
   FmZumenFont.P_CData := CData ;
   FmZumenFont.ShowModal ;
end;

// [描画]
procedure TForm1.Button8Click(Sender: TObject);
var
   tim : TTime ;
   x1,y1,x2,y2,col,ltp,wid,i,j : integer ;
   mc : integer ;
   lx1,ly1,lx2,ly2 : double ;
   p : TTreeNode ;
   lx,ly : array of double ;
   // wx1,wx2,wx3,wx4, wx5,wx6,wx7,wx8, wx9 : double ;
   // wy1,wy2,wy3,wy4, wy5,wy6,wy7,wy8, wy9 : double ;
   s : string ;
begin
   ScrX := PaintBox1.Width;
   ScrY := PaintBox1.Height;
   ZInit;   // 関連する各変数の初期化

   Z2D(x1,y1, 0.0,0.0);
   Z2D(x2,y2, CData.zp.x,CData.zp.y);

   Label1.Caption := '左下：'+DStr(WndX1,2)+','+DStr(WndY1,2) ;
   Label2.Caption := '右上：'+DStr(WndX2,2)+','+DStr(WndY2,2) ;

   with CData do begin
      DataClearZukei ;  // 図形データクリア

      // 文字フォント
      if (zFntN = 0) then begin
         AddFont('ＭＳ ゴシック');
         AddFont('ＭＳ 明朝');
         AddFont('ＭＳ Ｐゴシック');
         AddFont('ＭＳ Ｐ明朝');
      end;
      // レイヤ
      if (zLayN = 0) then begin
         AddLayer('LAYER1',1,1,1,1,1);
      end;

      // 複合図形
      dFzk  := nil;
      dFzkN := 0;
      for i:=0 to fDefN-1 do begin
         with fDef[i] do begin
            mFzk := nil;
         end;
      end;
      fDef  := nil;
      fDefN := 0;

      AddFZukeiDef('部分図Ａ',1);      // XY座標系
      AddFZukeiDef('部分図Ｂ',2);      // YX座標系
      AddFZukeiDef('作図グループＣ',3);
      AddFZukeiDef('作図部品Ｄ',4);
      AddFZukeiDef('作図部品Ｅ',4);

      // シンボル定義
      DataClearSymbol ;
      AddSymbolDef('シンボルA');

      AddDataFZukei('',0,'部分図Ａ',200.0,250.0,30.0,1.5,1.2);
      AddDataFZukei('部分図Ａ',0,'作図グループＣ',50.0,50.0,30,1.0,1.0);   // 作図グループは引数を指定しても無効化される
      AddDataFZukei('作図グループＣ',0,'作図部品Ｄ',50.0,50.0,30,0.5,0.5);
      AddDataFZukei('',0,'部分図Ｂ',400.0,250.0,0.0,1.0,1.0);
      AddDataFZukei('部分図Ｂ',0,'作図部品Ｄ',10.0,20.0,0.0,2.0,1.0);
      AddDataFZukei('部分図Ｂ',0,'作図部品Ｅ',10.0,20.0,0.0,1.0,2.0);
      AddDataFZukei('作図部品Ｄ',0,'作図部品Ｅ',10.0,20.0,0.0,0.5,0.5);
      // AddDataFZukei('作図部品Ｅ',0,'作図部品Ｄ',0.0,0.0,0.0,1.0,1.0);
      // ↑このような指定をすると無限ループ状態になるので要注意
   end;

   // 表示ツリー生成
   CData.MakeFZukeiTree ;
   TreeView1.Items.Clear ;
   TreeView1.Items.Add(nil,'用紙');
   for i:=0 to CData.zFztN-1 do begin
      j := Cdata.zFzt[i].par ;
      p := TreeView1.Items[j+1] ;
      TreeView1.Items.AddChild(p, Cdata.zFzt[i].name);
   end;

   Screen.Cursor := crHourGlass ;
   tim := Now ;

   gp.SetDisplayMode(RadioGroup1.ItemIndex);
   gp.G_Start(PaintBox1.Canvas);
   BackCol := clWhite ;
   gp.G_Cls(BackCol);
   // 用紙枠描画
   gp.G_SetPen(clBlue);
   gp.G_Line(x1,y1, x2,y1);
   gp.G_Line(x2,y1, x2,y2);
   gp.G_Line(x2,y2, x1,y2);
   gp.G_Line(x1,y2, x1,y1);

   // 点マーカ・データ登録テスト
   //    表記要素／用紙上に直接
   col := 1 ;
   mc  := 1 ;
   for i:=1 to 20 do begin
      lx1 := i*50 ;
      ly1 := 50.0 ;
      CData.AddDataTen('', 1,col,mc, lx1,ly1,0.0,15.0);
      Inc(col);
      if (col > CData.zColN) then col := 1 ;
      Inc(mc);
      if (mc > 7) then mc := 1 ;
   end;

   // 点マーカ・データ登録テスト
   //    幾何要素／部分図以下に
   col := 1 ;
   mc  := 1 ;
   for i:=1 to 20 do begin
      lx1 := i*50 ;
      ly1 := 50.0 ;
      CData.AddDataTen('部分図Ａ', 1,col,mc, lx1,ly1,0.0,15.0);
      Inc(col);
      if (col > CData.zColN) then col := 1 ;
      Inc(mc);
      if (mc > 7) then mc := 1 ;
   end;

   // 線分データ登録テスト
   //    表記要素／用紙上に直接
   col := 1 ;
   ltp := 1 ;
   wid := 1 ;
   for i:=1 to 50 do begin
      lx1 := i*20 ;
      ly1 := 100.0 ;
      ly2 := 200.0 ;
      CData.AddDataLine('', 1,col,ltp,wid, lx1,ly1,lx1,ly2);
      Inc(col);
      if (col > CData.zColN) then col := 1 ;
      Inc(ltp);
      if (ltp > CData.zLtpN) then ltp := 1 ;
      Inc(wid);
      if (wid > CData.zWidN) then wid := 1 ;
   end;

   // 線分データ登録テスト
   //    幾何要素／部分図以下に
   col := 1 ;
   ltp := 1 ;
   wid := 1 ;
   for i:=1 to 50 do begin
      lx1 := i*20 ;
      ly1 := 100.0 ;
      ly2 := 200.0 ;
      CData.AddDataLine('部分図Ａ', 1,col,ltp,wid, lx1,ly1,lx1,ly2);
      Inc(col);
      if (col > CData.zColN) then col := 1 ;
      Inc(ltp);
      if (ltp > CData.zLtpN) then ltp := 1 ;
      Inc(wid);
      if (wid > CData.zWidN) then wid := 1 ;
   end;
{
   ※画面が見えにくいのでコメント化しておきます

   // 折線データ登録テスト
   //    表記要素／用紙上に直接
   SetLength(lx,5);
   SetLength(ly,5);
   lx1 := 0.0 ;
   ly1 := 0.0 ;
   lx2 := 200.0 ;
   ly2 := 150.0 ;
   lx[0] := lx1 ; ly[0] := ly1 ;
   lx[1] := lx2 ; ly[1] := ly1 ;
   lx[2] := lx2 ; ly[2] := ly2 ;
   lx[3] := lx1 ; ly[3] := ly2 ;
   lx[4] := lx1 ; ly[4] := ly1 ;
   CData.AddDataLines('', 1,2,2,1, 5, lx,ly);

   // 折線データ登録テスト
   //    幾何要素／部分図以下に
   CData.AddDataLines('部分図Ａ', 1,3,2,1, 5, lx,ly);

   for i:=0 to 3 do begin
      lx[i] := Random(100);
      ly[i] := Random(100);
   end;
   CData.AddDataLines('',         1,3,2,1, 4, lx,ly);
   CData.AddDataLines('部分図Ａ', 1,3,2,1, 4, lx,ly);

   // ベジェ曲線テスト
   CData.AddDataBezier('',         1,4,4,3, 30,4, lx,ly);
   CData.AddDataBezier('部分図Ａ', 1,6,3,3, 30,4, lx,ly);
   ｛
   SetLength(lx,10);
   SetLength(ly,10);

   for i:=0 to 9 do begin
      lx[i] := Random(100);
      ly[i] := Random(100);
   end;
   CData.AddDataLines('',         1,3,2,1, 10, lx,ly);
   CData.AddDataLines('部分図Ａ', 1,3,2,1, 10, lx,ly);

   // ベジェ曲線テスト
   CData.AddDataBezier('',         1,4,4,3, 30,10, lx,ly);
   CData.AddDataBezier('部分図Ａ', 1,6,3,3, 30,10, lx,ly);
   ｝

   for i:=0 to 4 do begin
      lx[i] := Random(100) + 100 ;
      ly[i] := Random(100);
   end;
   // lx[4] := lx[0];   // 閉図形
   // ly[4] := ly[0];
   CData.AddDataLines('',         1,3,2,1, 5, lx,ly);
   CData.AddDataLines('部分図Ａ', 1,3,2,1, 5, lx,ly);

   ｛
   // Ｂスプライン曲線テスト
   CData.AddDataBspline('',         1, 9,6,3, 30,5, lx,ly);
   CData.AddDataBspline('部分図Ａ', 1,10,5,3, 30,5, lx,ly);
   ｝
   // スプライン曲線テスト
   CData.AddDataSpline('',         1, 9,7,1, 1,30,5, 0.5, lx,ly); // Cスプライン(点線)
   CData.AddDataSpline('部分図Ａ', 1, 9,7,1, 1,30,5, 0.5, lx,ly);
   CData.AddDataSpline('',         1, 2,2,3, 2,30,5, 0.0, lx,ly); // ベジェ補間（赤色）
   CData.AddDataSpline('部分図Ａ', 1, 2,2,3, 2,30,5, 0.0, lx,ly);
   CData.AddDataSpline('',         1, 4,4,3, 3,30,5, 0.0, lx,ly); // NUBS補間（青色）
   CData.AddDataSpline('部分図Ａ', 1, 4,4,3, 3,30,5, 0.0, lx,ly);

   lx := nil;
   ly := nil;
}
{
   ※画面が見えにくいのでコメント化しておきます

   // 円データ登録テスト
   col := 1 ;
   ltp := 1 ;
   wid := 1 ;
   for i:=1 to 10 do begin
      lx1 := i*5 ;
      CData.AddDataCircle('', 1,col,ltp,wid, 0.0,50.0,lx1);
      CData.AddDataCircle('部分図Ａ', 1,col,ltp,wid, 0.0,50.0,lx1);
      Inc(col);
      if (col > CData.zColN) then col := 1 ;
      Inc(ltp);
      if (ltp > CData.zLtpN) then ltp := 1 ;
      Inc(wid);
      if (wid > CData.zWidN) then wid := 1 ;
   end;

   // 円弧データ登録テスト
   col := 1 ;
   ltp := 1 ;
   wid := 1 ;
   for i:=1 to 10 do begin
      lx1 := i*5 ;
      CData.AddDataArc('', 1,col,ltp,wid,0, 80.0,0.0,lx1,0.0,180.0);
      CData.AddDataArc('部分図Ａ', 1,col,ltp,wid,1, 80.0,0.0,lx1,0.0,180.0);
      Inc(col);
      if (col > CData.zColN) then col := 1 ;
      Inc(ltp);
      if (ltp > CData.zLtpN) then ltp := 1 ;
      Inc(wid);
      if (wid > CData.zWidN) then wid := 1 ;
   end;

   // 楕円データ登録テスト
   col := 1 ;
   ltp := 1 ;
   wid := 1 ;
   for i:=1 to 10 do begin
      lx1 := i*10 ;
      ly1 := i*5 ;
      CData.AddDataEllipse('', 1,col,ltp,wid, 150.0,50.0,lx1,ly1,30.0);
      CData.AddDataEllipse('部分図Ａ', 1,col,ltp,wid, 150.0,50.0,lx1,ly1,30.0);
      Inc(col);
      if (col > CData.zColN) then col := 1 ;
      Inc(ltp);
      if (ltp > CData.zLtpN) then ltp := 1 ;
      Inc(wid);
      if (wid > CData.zWidN) then wid := 1 ;
   end;

   // 楕円弧データ登録テスト
   col := 1 ;
   ltp := 1 ;
   wid := 1 ;
   for i:=1 to 10 do begin
      lx1 := i*10 ;
      ly1 := i*5 ;
      CData.AddDataEllipseArc('', 1,col,ltp,wid,0, 200.0,00.0,lx1,ly1,30.0,0.0,180.0);
      CData.AddDataEllipseArc('部分図Ａ', 1,col,ltp,wid,1, 200.0,0.0,lx1,ly1,30.0,0.0,180.0);
      Inc(col);
      if (col > CData.zColN) then col := 1 ;
      Inc(ltp);
      if (ltp > CData.zLtpN) then ltp := 1 ;
      Inc(wid);
      if (wid > CData.zWidN) then wid := 1 ;
   end;

   // 文字データ登録テスト
   col := 1 ;
   for i:=1 to 10 do begin
      lx1 := i*10 ;
      ly1 := i*5 ;
   // CData.AddDataLine(''        , 1,col,0,6, lx1,-50,lx1,ly1);
   // CData.AddDataLine('部分図Ａ', 1,col,0,6, lx1,-50,lx1,ly1);
      CData.AddDataText(''        ,'ABCあいう絵ĂĠġĢģ〠〄亹仵', 1,col,1,1,1, lx1,ly1     , 10.0, 50.0, 0.0, -30.0, 0.0);
   // CData.AddDataText(''        ,'ABCdefghijklmn'          , 1,col,1,1,1, lx1,ly1+50.0, 10.0, 30.0, 0.0, -30.0, 0.0);
      CData.AddDataText('部分図Ａ','ABCあいう絵ĂĠġĢģ〠〄亹仵', 1,col,2,1,1, lx1,ly1     , 10.0, 50.0, 0.0, -30.0, 0.0);
   // CData.AddDataText('部分図Ａ','ABCdefghijklmn'          , 1,col,1,1,1, lx1,ly1+50.0, 10.0, 30.0, 0.0, -30.0, 0.0);
      Inc(col);
      if (col > CData.zColN) then col := 1 ;
   end;
   for i:=1 to 10 do begin
      lx1 := i*10 ;
      ly1 := i*5  + 20 ;
   // CData.AddDataLine(''        , 1,col,0,6, 0,ly1,lx1,ly1);
   // CData.AddDataLine('部分図Ａ', 1,col,0,6, 0,ly1,lx1,ly1);
      CData.AddDataText(''        ,'（ABCあいう）、，．『絵ĂĠġĢģ〠〄亹仵』。', 1,col,3,1,2, lx1,ly1     , 100.0, 10.0, 1.0, 30.0, 0.0);
   // CData.AddDataText(''        ,'ABCdefghijklmn'          , 1,col,3,1,2, lx1,ly1+50.0,  60.0, 20.0, 0.0, 30.0, 0.0);
      CData.AddDataText('部分図Ａ','【ABCあいう】、，．「絵ĂĠġĢģ〠〄亹仵」。', 1,col,4,1,2, lx1,ly1     , 100.0, 10.0, 0.0, 30.0, 0.0);
   // CData.AddDataText('部分図Ａ','ABCdefghijklmn'          , 1,col,4,1,2, lx1,ly1+50.0,  60.0, 20.0, 0.0, 30.0, 0.0);
      Inc(col);
      if (col > CData.zColN) then col := 1 ;
   end;
}
   // クロソイド曲線テスト
   lx2 := 70.0 ;
   CData.AddDataClothoid(''         , 1,3,1,1,0,100, 100,50, lx2,0.0, 0.0,500.0);
   CData.AddDataClothoid('部分図Ａ' , 1,3,1,1,0,100, 100,50, lx2,0.0, 0.0,500.0);

   // シンボル図形テスト
   CData.AddDataTen( 'シンボルA', 1, 1,6, 0,0,0,5);
   CData.AddDataLine('シンボルA', 1,10,1,1, -10,-10,  10,-10);
   CData.AddDataLine('シンボルA', 1,11,1,1,  10,-10,  10, 10);
   CData.AddDataLine('シンボルA', 1,12,1,1,  10, 10, -10, 10);
   CData.AddDataLine('シンボルA', 1,13,1,1, -10, 10, -10,-10);
   CData.AddDataLine('シンボルA', 1,14,1,1, -10,-10,  10, 10);
   CData.AddDataLine('シンボルA', 1,15,1,1, -10, 10,  10,-10);

   CData.AddDataSZukei(''        , 1,0,0,'シンボル' , 100,50,0.0,1.0);   // シンボルなし
   CData.AddDataSZukei('部分図Ａ', 1,0,0,'シンボル' , 100,50,0.0,1.0);
   CData.AddDataSZukei(''        , 1,0,0,'シンボルA', 100,80,0.0,1.0);
   CData.AddDataSZukei('部分図Ａ', 1,0,0,'シンボルA', 100,80,0.0,1.0);
   CData.AddDataSZukei(''        , 1,1,2,'シンボルA', 130,80,30.0,0.5);
   CData.AddDataSZukei('部分図Ａ', 1,1,2,'シンボルA', 130,80,30.0,0.5);

   // 矢印データ登録テスト
   for i:=1 to 11 do begin
      lx1 := i * 20 ;
      ly1 := 20.0 ;
      lx2 := lx1 + 15*Cos(0/180.0*Pi) ;
      ly2 := ly1 + 15*Sin(0/180.0*Pi) ;
      CData.AddDataLine(''        , 1,2,1,1, lx1,ly1,lx2,ly2);
      CData.AddDataLine('部分図Ａ', 1,2,1,1, lx1,ly1,lx2,ly2);
      CData.AddDataLine(''        , 1,2,1,1, lx1,ly1,lx1,ly1-10);
      CData.AddDataLine('部分図Ａ', 1,2,1,1, lx1,ly1,lx1,ly1-10);

      CData.AddDataArrow(''        , 1,1,i, lx1,ly1,0.0,1.0);
      CData.AddDataArrow('部分図Ａ', 1,1,i, lx1,ly1,0.0,1.0);
   end;
{
   // 直線寸法テスト
   CData.AddDataDimLine('','123.456',1,1,1,1, 1,1,1,
      1,2, 1,2, 1,2,1, 25,120,135,120, 30,0,30,10,30,125, 130,0,130,10,130,125,
      30,120,1,  130,120,1, 80,123,10,50,0,0,0);
   CData.AddDataDimLine('部分図Ａ','123.456',1,1,1,1, 1,1,1,
      1,2, 1,2, 1,2,1, 25,120,135,120, 30,0,30,10,30,125, 130,0,130,10,130,125,
      30,120,1,  130,120,1, 80,123,10,50,0,0,0);

   // 角度寸法テスト
   wx1 := 80 +  10*Cos(30/180*Pi);
   wy1 := 80 +  10*Sin(30/180*Pi);
   wx2 := 80 +  20*Cos(30/180*Pi);
   wy2 := 80 +  20*Sin(30/180*Pi);
   wx3 := 80 + 100*Cos(30/180*Pi);
   wy3 := 80 + 100*Sin(30/180*Pi);
   wx4 := 80 + 110*Cos(30/180*Pi);
   wy4 := 80 + 110*Sin(30/180*Pi);

   wx5 := 80 +  10*Cos(120/180*Pi);
   wy5 := 80 +  10*Sin(120/180*Pi);
   wx6 := 80 +  20*Cos(120/180*Pi);
   wy6 := 80 +  20*Sin(120/180*Pi);
   wx7 := 80 + 100*Cos(120/180*Pi);
   wy7 := 80 + 100*Sin(120/180*Pi);
   wx8 := 80 + 110*Cos(120/180*Pi);
   wy8 := 80 + 110*Sin(120/180*Pi);

   wx9 := 80 + 105*Cos(75/180*Pi);
   wy9 := 80 + 105*Sin(75/180*Pi);
   lx1 := 75 - 90 ;

   CData.AddDataDimAngle('','10°20′30″',1,1,1,1, 1,1,1,
      1,2, 1,2, 1,2,1, 80,80,100,20,130, wx1,wy1,wx2,wy2,wx4,wy4, wx5,wy5,wx6,wy6,wx8,wy8,
      wx3,wy3,1,  wx7,wy7,1, wx9,wy9,10,50,0,lx1,0);
   CData.AddDataDimAngle('部分図Ａ','10°20′30″',1,1,1,1, 1,1,1,
      1,2, 1,2, 1,2,1, 80,80,100,20,130, wx1,wy1,wx2,wy2,wx4,wy4, wx5,wy5,wx6,wy6,wx8,wy8,
      wx3,wy3,1,  wx7,wy7,1, wx9,wy9,10,50,0,lx1,0);

   // 直径寸法テスト
   wx1 := 80.0 ;
   wy1 := 80.0 ;
   lx1 := 50.0 ;
   wx2 := wx1 + (lx1+10.0)*Cos(60.0/180.0*Pi);
   wy2 := wy1 + (lx1+10.0)*Sin(60.0/180.0*Pi);
   wx3 := wx1 + (lx1+10.0)*Cos((60.0+180.0)/180.0*Pi);
   wy3 := wy1 + (lx1+10.0)*Sin((60.0+180.0)/180.0*Pi);
   wx4 := wx1 + lx1*Cos(60.0/180.0*Pi);
   wy4 := wy1 + lx1*Sin(60.0/180.0*Pi);
   wx5 := wx1 + lx1*Cos((60.0+180.0)/180.0*Pi);
   wy5 := wy1 + lx1*Sin((60.0+180.0)/180.0*Pi);
   wx6 := (wx2+wx3)/2.0 + 2.0*Cos((60.0+90.0)/180.0*Pi);
   wy6 := (wy2+wy3)/2.0 + 2.0*Sin((60.0+90.0)/180.0*Pi);;
   s := 'φ' + DStr(lx1*2.0,1) ;
   ly1 := 5.0*Length(s);

   CData.AddDataCircle(''        , 1,1,1,8, wx1,wy1,lx1);
   CData.AddDataCircle('部分図Ａ', 1,1,1,8, wx1,wy1,lx1);
   CData.AddDataDimDiameter(''        ,s, 1,3,1,1, 1,
      6,2, 6,2, 1,2,1, wx2,wy2,wx3,wy3, wx4,wy4,1.5, wx5,wy5,1.5,
      wx6,wy6, 10,ly1,0.0,60.0,0);
   CData.AddDataDimDiameter('部分図Ａ',s, 1,3,1,1, 1,
      6,2, 6,2, 1,2,1, wx2,wy2,wx3,wy3, wx4,wy4,1.5, wx5,wy5,1.5,
      wx6,wy6, 10,ly1,0.0,60.0,0);
}
   SetLength(lx,5);
   SetLength(ly,5);
   for i:=0 to 4 do begin
      lx[i] := Random(100)+10;
      ly[i] := Random(100)+10;
   end;
   s   := 'バルーン' ;
   lx2 := 5.0*Length(s);
   ly2 := Sqrt(5.0*5.0/4.0+lx2*lx2/4.0) + 1.0 ;
   lx1 := lx[4] + ly2*Cos(Angle(lx[4]-lx[3],ly[4]-ly[3])) ;
   ly1 := ly[4] + ly2*Sin(Angle(lx[4]-lx[3],ly[4]-ly[3])) ;
   CData.AddDataDimBalloon('',         s, 1,4,2,1, 1,
      5, 6,1,5,1, lx,ly, lx1,ly1,ly2, 1.5, lx1,ly1, 10,lx2,0.0,0.0,0);
   CData.AddDataDimBalloon('部分図Ａ', s, 1,4,2,1, 1,
      5, 6,1,5,1, lx,ly, lx1,ly1,ly2, 1.5, lx1,ly1, 10,lx2,0.0,0.0,0);

   SetLength(lx,6);
   SetLength(ly,6);
   lx[5] := lx[0] ;  // 閉図形にする
   ly[5] := ly[0] ;
   CData.AddCCurveDef(1,1,1,1,1);      // 複合曲線定義 #1
   CData.AddCCrvDataLines(1,6,lx,ly);  // 折線

   lx := nil;
   ly := nil;

   DisplayAllData ;  // 全データ表示


   gp.G_End;

   Screen.Cursor := crDefault ;
   LongTimeFormat := 'hh:nn:ss.zzz';
   StatusBar1.SimpleText := TimeToStr(Now-tim);
end;

end.
