unit UnitGraph;

interface

uses
   Windows, SysUtils, Graphics, Math, GDIPAPI, GDIPOBJ, Direct2D, D2D1,
   UnitFunc ;

type
   TGraphClass = class
   public
      { Public 錾 }
      DisplayMode : integer ;    // `惂[h 0:GDI 1:GDI+ 2:Direct2D
      constructor Create;
      destructor Free;
      procedure DataInit;
      procedure SetDisplayMode(m:integer);
      procedure G_Start(C:TCanvas);
      procedure G_End ;
      procedure G_Cls(col:integer) ;
      procedure G_SetPen(col:integer) ;
      procedure G_SetWidth(wid:integer) ;
      procedure G_Line(x1,y1,x2,y2:integer) ;
      procedure G_Circle(x,y,r:integer) ;
      procedure G_CircleF(x,y,r:integer) ;
      procedure G_Polygon(n:integer;p:array of TPoint) ;
      procedure G_Text1(at,x,y,h,w:integer;an,sl:double;fo,st:string);
      function  G_TextWidth(at,h,w:integer;f,s:string):integer;
   private
      { Private 錾 }
      Ca: TCanvas ;
      gra : TGPGraphics;
      pen : TGPPen;
      br0 : TGPSolidBrush;
      D2DCanvas : TDirect2DCanvas ;
      D2Dfa : ID2D1Factory ;
      D2Dss : ID2D1StrokeStyle ;
      D2Dbr : ID2D1Brush;
   end;

implementation

// 
constructor TGraphClass.Create;
begin
   DataInit ;
end;

// 
destructor TGraphClass.Free;
begin
   Ca := nil;
   if (gra <> nil) then begin
      gra.Free;
      gra := nil;
   end;
   if (pen <> nil) then begin
      pen.Free;
      pen := nil;
   end;
   if (br0 <> nil) then begin
      br0.Free;
      br0 := nil;
   end;
   if (D2DCanvas <> nil) then begin
      D2DCanvas.Free;
      D2DCanvas := nil;
   end;
end;

// lZbg
procedure TGraphClass.DataInit;
begin
   DisplayMode := 0;
   Ca := nil;
   gra:= nil;
   pen:= nil;
   br0:= nil;
   D2DCanvas := nil;
end;

// `惂[hݒ
//    m : 0:GDI 1:GDI+ 2:Direct2D
//    Direct2Dg邩ǂ𔻒肵DisplayModeɓ
procedure TGraphClass.SetDisplayMode(m:integer);
begin
   if (m < 0)or(m > 2) then m:=0;
   if (m = 2) then
      if not(TDirect2DCanvas.Supported) then m:=0;
   DisplayMode := m ;
end;

// `Jn
//    C : `
//    `sŏɕKs
procedure TGraphClass.G_Start(C:TCanvas);
begin
   Ca := C ;
   case(DisplayMode)of
   0: begin     // GDI
         with Ca do begin
            Pen.Color := clBlack;
            Pen.Width := 1;
            Pen.Style := psSolid;
         end;
      end;
   1: begin     // GDI+
         gra := TGPGraphics.Create(Ca.Handle);
         gra.SetSmoothingMode(SmoothingModeHighSpeed);
         pen := TGPPen.Create(MakeColor(255, 0, 0, 0));
         pen.SetWidth(1.0);
         // [ۂݒ
         pen.SetDashStyle(DashStyleSolid);
         pen.SetStartCap(LineCapRound);
         pen.SetEndCap(LineCapRound);
         pen.SetLineJoin(LineJoinRound);
         // uV
         br0 :=TGPSolidBrush.Create(MakeColor(255, 0, 0, 0));
         // 
         gra.SetTextRenderingHint(TextRenderingHintSystemDefault);
       end;
   2: begin     // Direct2D
         D2DCanvas := TDirect2DCanvas.Create(Ca, Ca.ClipRect);
         with D2DCanvas do begin
            BeginDraw;
            RenderTarget.SetAntialiasMode(D2D1_ANTIALIAS_MODE_ALIASED); // A`GCAX
            RenderTarget.SetTextAntialiasMode(D2D1_TEXT_ANTIALIAS_MODE_GRAYSCALE);
            Pen.Color := clBlack;
            Pen.Width := 1;
            Pen.Style := psSolid ;
            // [ۂݒ  `RenderTargetɑ΂čs
            RenderTarget.GetFactory(D2Dfa);
            D2Dfa.CreateStrokeStyle(
               D2D1StrokeStyleProperties(D2D1_CAP_STYLE_ROUND,D2D1_CAP_STYLE_ROUND,D2D1_CAP_STYLE_ROUND,
               D2D1_LINE_JOIN_ROUND,10,D2D1_DASH_STYLE_SOLID,0),nil,0,D2Dss);
            D2Dbr := CreateBrush(Pen.Color);
         end;
      end;
   end;
end;

// `I
//    `I鎞ɕKs
procedure TGraphClass.G_End ;
begin
   if (Ca = nil) then exit ;
   case(DisplayMode)of
   1: begin     // GDI+
         pen.Free;   pen := nil;
         br0.Free;   br0 := nil;
         gra.Free;   gra := nil;
      end;
   2: begin     // Direct2D
         with D2DCanvas do begin
            EndDraw;
            Free;
         end;
          D2DCanvas := nil;
      end;
   end;
end;

// ʃNA
//    col : wiF(RGB)
procedure TGraphClass.G_Cls(col:integer) ;
begin
   case(DisplayMode)of
   0: begin     // GDI
         with Ca do begin
            Brush.Color := col ;
            Brush.Style := bsSolid ;
            Fillrect(ca.ClipRect);
         end;
      end;
   1: begin     // GDI+
         gra.Clear(ColorRefToARGB(col)) ;
      end;
   2: begin     // Direct2D
         with D2DCanvas do begin
            RenderTarget.Clear(D2D1ColorF(col));
         end;
      end;
   end;
end;

// yݒ
//    col : \F(RGB)
procedure TGraphClass.G_SetPen(col:integer) ;
begin
   case(DisplayMode)of
   0: begin     // GDI
         with Ca do begin
            Pen.Color := col ;
            Brush.Color := col ;
         end;
      end;
   1: begin     // GDI+
         pen.SetColor(ColorRefToARGB(col)) ;
         br0.SetColor(ColorRefToARGB(col)) ;
      end;
   2: begin     // Direct2D
         with D2DCanvas do begin
            Pen.Color := col ;
            D2Dbr := CreateBrush(Pen.Color);
         end;
      end;
   end;
end;

// yݒ
//    wid : 
procedure TGraphClass.G_SetWidth(wid:integer) ;
begin
   case(DisplayMode)of
   0: begin     // GDI
         with Ca do begin
            Pen.Width := wid ;
         end;
      end;
   1: begin     // GDI+
         pen.SetWidth(wid) ;
      end;
   2: begin     // Direct2D
         with D2DCanvas do begin
            Pen.Width := wid ;
         end;
      end;
   end;
end;

// `
//    x1,y1 : n_
//    x2,y2 : I_
procedure TGraphClass.G_Line(x1,y1,x2,y2:integer) ;
begin
   case(DisplayMode)of
   0: begin     // GDI
         with Ca do begin
            MoveTo(x1,y1);
            LineTo(x2,y2);
         end;
      end;
   1: begin     // GDI+
         gra.DrawLine(pen, x1,y1, x2,y2);
      end;
   2: begin     // Direct2D
         with D2DCanvas do begin
            RenderTarget.DrawLine(D2D1PointF(x1,y1),D2D1PointF(x2,y2),D2Dbr,Pen.Width,D2Dss);
         end;
      end;
   end;
end;

// ~`
//    x,y : S_
//    r   : a
procedure TGraphClass.G_Circle(x,y,r:integer) ;
begin
   if (r < 1) then r := 1 ;
   case(DisplayMode)of
   0: begin     // GDI
         with Ca do begin
            Brush.Style := bsClear ;
            Ellipse(x-r,y-r, x+r,y+r);
         end;
      end;
   1: begin     // GDI+
         gra.DrawEllipse(pen, x-r,y-r, r+r,r+r);
      end;
   2: begin     // Direct2D
         with D2DCanvas do begin
            RenderTarget.DrawEllipse(D2D1Ellipse(D2D1PointF(x,y),r,r),D2Dbr,Pen.Width,D2Dss);
         end;
      end;
   end;
end;

// hׂ~`
//    x,y : S_
//    r   : a
procedure TGraphClass.G_CircleF(x,y,r:integer) ;
begin
   if (r < 1) then r := 1 ;
   case(DisplayMode)of
   0: begin     // GDI
         with Ca do begin
            Brush.Style := bsSolid ;
            Brush.Color := Pen.Color ;
            Ellipse(x-r,y-r, x+r,y+r);
            Brush.Style := bsClear ;
         end;
      end;
   1: begin     // GDI+
         gra.FillEllipse(br0, x-r,y-r, r+r,r+r);
      end;
   2: begin     // Direct2D
         with D2DCanvas do begin
            RenderTarget.FillEllipse(D2D1Ellipse(D2D1PointF(x,y),r,r),D2Dbr);
         end;
      end;
   end;
end;

// |S`
procedure TGraphClass.G_Polygon(n:integer;p:array of TPoint) ;
var
   i : integer ;
   pnts: array of TGPPointF ;
   geo: ID2D1PathGeometry;
   aSink: ID2D1GeometrySink;
   pntsD: array of TD2DPoint2f;
begin
   case(DisplayMode)of
   0: begin     // GDI
         with Ca do begin
            Pen.Width   := 1 ;   //
            Brush.Style := bsSolid ;
            Brush.Color := Pen.Color ;
            Polygon(p);
            Brush.Style := bsClear ;
         end;
      end;
   1: begin     // GDI+
         SetLength(pnts, n);
         for i:=0 to n-1 do begin
            pnts[i].X := p[i].x ;
            pnts[i].Y := p[i].y ;
         end;
         gra.FillPolygon(br0, PGPPointF(@pnts[0]), n) ;
         // gra.DrawPolygon(pen, PGPPointF(@pnts[0]), n) ;
         pnts := nil ;
      end;
   2: begin     // Direct2D
         D2DFactory.CreatePathGeometry(geo);
         geo.Open(aSink);
         pntsD := nil ;
         try
            aSink.SetFillMode(D2D1_FILL_MODE_WINDING);
            aSink.BeginFigure(
               D2D1PointF(p[0].x,p[0].y),
               D2D1_FIGURE_BEGIN_FILLED
            );
            SetLength(pntsD, n);
            for i:=0 to n-1 do begin
               pntsD[i].X := p[i].x ;
               pntsD[i].Y := p[i].y ;
            end;
            aSink.AddLines(@pntsD[0], Length(pntsD));
            aSink.EndFigure(D2D1_FIGURE_END_CLOSED);
            aSink.Close;
            pntsD := nil ;
         except
            aSink.Close;
            pntsD := nil ;
         end;
         with D2DCanvas do begin
            RenderTarget.FillGeometry(geo,D2Dbr);
            // RenderTarget.DrawGeometry(geo,D2Dbr,Pen.Width,D2Dss);
         end;
      end;
   end;
end;

// `
//    at :   +1: +2:Α +4: +8:
//    x,y: ʒui_j
//    h,w: E
//    an : px[]
//    sl : Xgpx[] GDIł͖
//    fo : tHg
//    st : 
//    GDI+ADirect2D͏cptHg(@`)͎gps\Ȃ̂Œ
procedure TGraphClass.G_Text1(at,x,y,h,w:integer;an,sl:double;fo,st:string);
var
   LogFont : TLogFont ;
   lf : HFONT ;
   ff : TGPFontFamily;
   fon: TGPFont;
   m  : TGPMatrix ;
   xy : double ;
   t : D2D_MATRIX_3X2_F ;
   mt,mt1 : TMatrix ;
begin
   if (w < 2) then w := 2 ;
   if (h < 2) then h := 2 ;
   xy := w/h;
   case(DisplayMode)of
   0: begin     // GDI
         with LogFont do begin
            lfHeight       := h ;               // 
            lfWidth        := w div 2 ;         // 
            lfEscapement   := Round(an*10);     // ]px[] 10{l
            lfOrientation  := Round(an*10);     // lfEscapementƓl
            lfWeight       := FW_NORMAL ;       // w ʏ FW_NORMAL
            lfItalic       := 0 ;               // Α̎w L=1 =0
            lfUnderline    := 0 ;               // w L=1 =0
            lfStrikeOut    := 0 ;               // w L=1 =0
            if ((at and 1) > 0) then lfWeight := FW_BOLD ;
            if ((at and 2) > 0) then lfItalic := 1 ;
            if ((at and 4) > 0) then lfUnderline := 1 ;
            if ((at and 8) > 0) then lfStrikeOut := 1 ;
            lfCharSet      := DEFAULT_CHARSET ;
            lfOutPrecision := OUT_DEFAULT_PRECIS ;
            lfClipPrecision:= CLIP_DEFAULT_PRECIS ;
            lfQuality      := DEFAULT_QUALITY ;
            lfPitchAndFamily  := DEFAULT_PITCH ;
            StrPCopy(lfFaceName ,fo);
         end;
         lf := CreateFontIndirect(LogFont);
         with Ca do begin
            Font.Handle := lf ;
            Font.Color  := Pen.Color ;
            Brush.Style := bsClear ;
            TextOut(x,y,st);
         end;
         DeleteObject(lf);
      end;
   1: begin     // GDI+    GDI,Direct2DƈʒuE傫ȂׁAڕʂŔĂ܂
         ff := nil;
         try
            ff := TGPFontFamily.Create(fo);
            fon:= nil;
            try
               fon:= TGPFont.Create(ff, h, at, UnitPixel);
               MtxMove(mt, -0.17/xy*w,0.0);  // ڕʔ
               MtxScale(mt1, xy,1.0);
               mt := MtxMult(mt, mt1);
               MtxSlant(mt1, -Tan(sl/180.0*Pi),0.0);
               mt := MtxMult(mt, mt1);
               MtxMove(mt1, h*Tan(sl/180.0*Pi),0.0);
               mt := MtxMult(mt, mt1);
               MtxRotD(mt1, -an);
               mt := MtxMult(mt, mt1);
               MtxMove(mt1, x,y);
               mt := MtxMult(mt, mt1);
               m := TGPMatrix.Create(mt.t11,mt.t12, mt.t21,mt.t22, mt.t31, mt.t32);
               gra.SetTransform(m);
               m.Free ;
               gra.DrawString(st,-1,fon,MakePoint(0.0,0.0),br0);
               gra.ResetTransform;
            except
               ;
            end;
            if (fon <> nil) then fon.Free;
         except
            ;
         end;
         if (ff <> nil) then ff.Free;
      end;
   2: begin     // Direct2D
         with D2DCanvas do begin
            MtxScale(mt, xy,1.0);
            MtxSlant(mt1, -Tan(sl/180.0*Pi),0.0);
            mt := MtxMult(mt, mt1);
            MtxMove(mt1, h*Tan(sl/180.0*Pi),0.0);
            mt := MtxMult(mt, mt1);
            MtxRotD(mt1, -an);
            mt := MtxMult(mt, mt1);
            MtxMove(mt1, x,y);
            mt := MtxMult(mt, mt1);
            t._11 := mt.t11 ;
            t._12 := mt.t12 ;
            t._21 := mt.t21 ;
            t._22 := mt.t22 ;
            t._31 := mt.t31 ;
            t._32 := mt.t32 ;
            RenderTarget.SetTransform(t);

            Brush.Style := bsClear ;
            Font.Brush.Handle := D2Dbr ;
            Font.Name   := fo ;
            Font.Style  := [] ;
            if ((at and 1) > 0) then Font.Style := Font.Style + [fsBold] ;
            if ((at and 2) > 0) then Font.Style := Font.Style + [fsItalic] ;
            if ((at and 4) > 0) then Font.Style := Font.Style + [fsUnderline] ;
            if ((at and 8) > 0) then Font.Style := Font.Style + [fsStrikeOut] ;
            Font.Height := - h ;
            TextOut(0,0,st);

            t._11 := 1.0 ;
            t._12 := 0.0 ;
            t._21 := 0.0 ;
            t._22 := 1.0 ;
            t._31 := 0.0 ;
            t._32 := 0.0 ;
            RenderTarget.SetTransform(t);
         end;
      end;
   end;
end;

// ʂɕ\镶擾
//    h : 
//    w : Sp
//    f : tHg
//    s : e
// (ret)  
function TGraphClass.G_TextWidth(at,h,w:integer;f,s:string):integer;
var
   LogFont : TLogFont ;
   lf : HFONT ;
begin
   with LogFont do begin
      lfHeight       := h ;         // 
      lfWidth        := w div 2 ;   // 
      lfEscapement   := 0 ;         // ]px[] 10{l
      lfOrientation  := 0 ;         // lfEscapementƓl
      lfWeight       := FW_NORMAL;  // w ʏ FW_NORMAL
      lfItalic       := 0 ;         // Α̎w L=1 =0
      lfUnderline    := 0 ;         // w L=1 =0
      lfStrikeOut    := 0 ;         // w L=1 =0
      if ((at and 1) > 0) then lfWeight := FW_BOLD ;
      if ((at and 2) > 0) then lfItalic := 1 ;
      if ((at and 4) > 0) then lfUnderline := 1 ;
      if ((at and 8) > 0) then lfStrikeOut := 1 ;
      lfCharSet      := DEFAULT_CHARSET ;
      lfOutPrecision := OUT_DEFAULT_PRECIS ;
      lfClipPrecision:= CLIP_DEFAULT_PRECIS ;
      lfQuality      := DEFAULT_QUALITY ;
      lfPitchAndFamily  := DEFAULT_PITCH ;
      StrPCopy(lfFaceName ,f);
   end;
   lf := CreateFontIndirect(LogFont);
   with Ca do begin
      Font.Handle := lf ;
      Result := TextWidth(s);
   end;
   DeleteObject(lf);
end;

end.
